import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.*;

public class ButtonPanel extends JPanel implements ActionListener {
	JButton reset, train, close, contour,imswitch, imsave, testImSave;
    JLabel testLabel;
    ImagePanel imagePanel;
    /**
	 * Creation of the default button panel for this application. A few buttons are added to save and load images compared to the original formulation. 
	 * @param imagePanel The panel on which the button is situated
	 */
    public ButtonPanel(ImagePanel imagePanel) {
    	this.imagePanel = imagePanel;
	    reset = new JButton("Reset");
	    reset.addActionListener(this);
	    train = new JButton("Train");
	    train.addActionListener(this);
	    close = new JButton("Close contour");
	    close.addActionListener(this);
	    imswitch = new JButton("Load image");
	    imswitch.addActionListener(this);
		imsave = new JButton("Save segmented image");
		imsave.addActionListener(this);
		testImSave = new JButton("Save trained image");
		testImSave.addActionListener(this);
	
	    add(reset);
	    add(train);
	    add(close);
	    add(imswitch);
	    add(imsave);
	    add(testImSave);
    }

    public void setText(String input){
    	testLabel.setText(input);
    }

    public void actionPerformed(ActionEvent e) {
    	if(e.getActionCommand() == "Reset") {
	    	imagePanel.reset();
	    }
	    else if(e.getActionCommand() == "Train") {
	        imagePanel.train();
	    }
	    else if(e.getActionCommand() == "Close contour") {
	        imagePanel.closeContour();
	    }
	    else if(e.getActionCommand() == "Load image") {
	        imagePanel.loadImage();
	    }
	    else if(e.getActionCommand() == "Save segmented image"){
		    imagePanel.saveImage("segmented");
		}
	    else if(e.getActionCommand() == "Save trained image"){
	    	imagePanel.saveImage("trained");
	    }
	    else{
	    	System.out.println("Unknown actionCommand" + e.getActionCommand());
	    }
	    	
    }

}
