import  javax.swing.*;
import java.awt.*;
import javax.imageio.*;
import java.io.*;

//panel used to draw image on
public class ImPanel extends JPanel
{
	//path of image
	private String path;
	
	//image object
	private Image img;
	
	public ImPanel(String path)	 throws IOException
	{
		//save path
		this.path = path;	
		
		//load image
		img = ImageIO.read(new File(path));
		
	}
	
	//override paint method of panel
	public void paint(Graphics g)
	{
		//draw the image
		if( img != null){
			System.out.println("Skal tegne bilde");
			g.drawImage(img,0,0, this);
		}
	}
	
}

//example of using image panel
class ImageFrame
{
	public static void main(String[] args) throws IOException
	{
		
		try
		{
		
			//create frame
			JFrame f = new JFrame();
			
			//ask for image file
			JFileChooser chooser = new JFileChooser();
			chooser.showOpenDialog(f);
			
			//create panel with selected file
			System.out.println(chooser.getSelectedFile().getPath());
			ImPanel panel = new ImPanel( chooser.getSelectedFile().getPath() );
			
			//add panel to pane
			f.getContentPane().add(panel);
			
			
			//show frame
			f.setBounds(0,0,800,800);
			f.setVisible(true);
		}
		catch(Exception e)
		{
			System.out.println ( "Please verify that you selected a valid image file");	
		}		
	}
}