% Function to compute the MAD measurement. 
function mad = compute_mad(paths, region_nr);

[height width] = size(paths);

extrema_input = compute_extrema(paths, region_nr);

first_y_w = 0;
last_y_w = 0;
first_y_e = 0;
last_y_e = 0;

for y = 1:height
    if(paths(y,extrema_input(4))==region_nr+1)
        if(first_y_w==0)
            first_y_w = y;
        end
        last_y_w = y;
    end
end

for y = 1:height
    if(paths(y,extrema_input(3))==region_nr+1)
        if(first_y_e==0)
            first_y_e = y;
        end
        last_y_e = y;
    end
end

correct_ys = [round((first_y_w+last_y_w)/2), round((first_y_e+last_y_e)/2)];
angle = atand( (correct_ys(2)-correct_ys(1)) / (extrema_input(3)-extrema_input(4)) );

hor_dist = sqrt( (correct_ys(2)-correct_ys(1))^2 + (extrema_input(3)-extrema_input(4))^2 );

image_rotated = abs(imrotate(paths, angle, 'bicubic', 'crop'))>1;
                                  
extrema_rotated = compute_extrema(image_rotated,0);

first_x_n = 0;
last_x_n = 0;

for x = 1:width
    if(image_rotated(extrema_rotated(1), x)==1)
        if(first_x_n==0)
            first_x_n = x;
        end
        last_x_n = x;
    end
end
correct_x = round((first_x_n+last_x_n)/2);
last_y = find(image_rotated(:,correct_x)==1, 1, 'last');

vert_dist = last_y-extrema_rotated(1);

mad = (hor_dist+vert_dist)/2;

function extrema = compute_extrema(paths, region_nr);

[height width] = size(paths);

extrema = [height 0 0 width];
for y = 1:height
    for x = 1:width
        if(paths(y,x) == region_nr+1)
            if (y<extrema(1))
                extrema(1)=y;
            end
            if (y>extrema(2))
                extrema(2)=y;
            end
            if (x>extrema(3))
                extrema(3)=x;
            end
            if (x<extrema(4))
                extrema(4)=x;
            end
        end            
    end 
end
