%Type is used to discriminate between %-deviations, and deviations in the
%distance. Type = 0 -> %-deviations. 
function [score, type] = compute_score(input_score, correct_score);

if(strcmp(class(input_score), 'char'))
    %We are computing the score for area/circumference/compactness
    input_score = str2num(input_score);
    correct_score = str2num(correct_score);
    score = abs(input_score-correct_score)/correct_score;
    type = 0;
    
elseif(strcmp(class(input_score), 'struct'))
    if(size(fieldnames(input_score),1)==2)
        score = sqrt( power( (str2num(input_score.x)-str2num(correct_score.x)), 2 ) + power( (str2num(input_score.y) - str2num(correct_score.y)), 2)  );
        type = 1;
    else
        match_moment = str2num(input_score.m1);
        labeled_moment = str2num(correct_score.m1);
        score = abs(match_moment - labeled_moment)/labeled_moment;
        type = 0;
    end
end