% Function to create an XML-representation suitable for the CBR-tool.
function create_xml_rep(regions, filename);

%%%%%initialisation%%%%%%%%%%%%% 
docNode = com.mathworks.xml.XMLUtils.createDocument('root'); 
docRootNode = docNode.getDocumentElement; 
docRootNode.setAttribute('xmlns:xsi', 'http://www.w3.org/2001/XMLSchema-instance' );
docRootNode.setAttribute('xsi:noNamespaceSchemaLocation', 'jcreekmodel.xsd' );

caseNode = docNode.createElement('case');
caseNode.setAttribute('description', '...');
caseNode.setAttribute('name', '...');

docRootNode.appendChild(caseNode);

findingNode = docNode.createElement('finding');
findingNode.setAttribute('relationType', 'belongs to');
findingNode.setAttribute('toEntity', regions.viewplane);
caseNode.appendChild(findingNode);
%%%%%end initialisation %%%%%%%%

regs = fieldnames(regions);
for r = 1:size(regs, 1)
    field = cell2mat(regs(r));
    if(strncmp(field, 'reg', 3))
        finding_node = docNode.createElement('finding');
        finding_node.setAttribute('relationType', 'has landmark');
        finding_node.setAttribute('toEntity', getfield(getfield(regions, field), 'name'));
        caseNode.appendChild(finding_node);   
    elseif(strcmp(field,'mad'))
        finding_node = docNode.createElement('finding');
        finding_node.setAttribute('relationType', 'has mad measurement');
        finding_node.setAttribute('toEntity', getfield(regions, field));
        caseNode.appendChild(finding_node);
    elseif(strcmp(field,'finding'))
        finding_node = docNode.createElement('finding');
        finding_node.setAttribute('relationType', 'has finding');
        finding_node.setAttribute('toEntity', getfield(getfield(regions, field), 'name'));
        caseNode.appendChild(finding_node);
    end
end

 xmlwrite(filename,docNode); 