% Function for computing the central moments. 
function central_moments = find_central_moments(paths, p1, q1, centroids, no_of_regions);

[Height Width] = size(paths);

for i = 1:no_of_regions
    centroid = centroids(:,i);
    for p = 0:p1
        for q = 0:q1
            c_mom = 0;
            for y = 1:Height
                for x = 1:Width
                    if(paths(y,x)==i+1)
                        c_mom = c_mom +((x-centroid(2))^p)*((y-centroid(1))^q);
                    end
                end
            end
            x_pos = 1 + (p*4)+q;
            if(x_pos~=-1)
                central_moments(i,x_pos) = c_mom;
            end
        end
    end
end