% Function computing the centroids of a given matrix of paths. 
function centroids = find_centroids(paths, no_of_regions);

[height width] = size(paths);
centroids = zeros(2,no_of_regions);

for i = 1:no_of_regions
    extrema = [height 0 0 width];
    for y = 1:height
        for x = 1:width
            if(paths(y,x) == i+1)
                if (y<extrema(1))
                    extrema(1)=y;
                end
                if (y>extrema(2))
                    extrema(2)=y;
                end
                if (x>extrema(3))
                    extrema(3)=x;
                end
                if (x<extrema(4))
                    extrema(4)=x;
                end
            end            
        end 
    end
    nw = [extrema(1), extrema(4)];
    ne = [extrema(1), extrema(3)];
    sw = [extrema(2), extrema(4)];
    se = [extrema(2), extrema(3)];
    centroids(:,i) = [extrema(1)+round((sw(1)-nw(1))/2), extrema(4)+round((se(2)-sw(2))/2)];
end
