% This function computes the invariant moments, based on the unscaled
% central moments. 
function invariant_moments = find_invariant_moments(unscaled_central_moments);

[no_of_regions width] = size(unscaled_central_moments);

final_moments = zeros(no_of_regions, 7);



for i = 1:no_of_regions
    u_02 = unscaled_central_moments(i,3);
    u_03 = unscaled_central_moments(i,4);
    u_11 = unscaled_central_moments(i,6);
    u_12 = unscaled_central_moments(i,7);
    u_20 = unscaled_central_moments(i,9);
    u_21 = unscaled_central_moments(i,10);
    u_30 = unscaled_central_moments(i,13);
    
    
    invariant_moments(i,1) = u_20 + u_02;
    invariant_moments(i,2) = (u_20 - u_02)^2 + 4*u_11^2;
    invariant_moments(i,3) = (u_30 - 3*u_12)^2 + (3*u_21 - u_03)^2;
    invariant_moments(i,4) = (u_30 + u_12)^2 + (u_21 + u_03)^2;
    invariant_moments(i,5) = (u_30-3*u_12)*(u_30+u_12)*( (u_30+u_12)^2 - 3*(u_21+u_03)^2 )  + ...
                             (3*u_21-u_03)*(u_21+u_03) * ( 3*(u_30 + u_12)^2 - (u_21 + u_03)^2 );
    invariant_moments(i,6) = (u_20-u_02) * ( (u_30 + u_12)^2 - (u_21 + u_03)^2 ) + ...
                             4*u_11*(u_30+u_12)*(u_21+u_03);
    invariant_moments(i,7) = (3*u_21 - u_03)*(u_30+u_12)*( (u_30+u_12)^2 - 3*(u_21+u_03)^2 ) - ...
                             (u_30-3*u_12)*(u_21+u_03)*( 3*(u_30 + u_12)^2 - (u_21+u_03)^2 );
    %invariant_moments(invariant_moments<5e-4)=0;
end
