% Function to compute the paths from the live-wire approach. An iterative
% approach is adopted. 
function [paths no_of_regions] = iterative_paths(image_matrix);

[Height Width] = size(image_matrix);
paths = zeros(Height, Width);

steps = [0 1; -1 1; -1 0; -1 -1; 0 -1; 1 -1; 1 0; 1 1];

max_label = 1;
for y = 1:Height
    for x = 1:Width
        if(image_matrix(y,x)==1 && paths(y,x)==0)
            [neighbours neighbour_label] = has_neighbours(paths, y, x, image_matrix);
            if(~neighbours)
                max_label = max_label+1;
                paths(y,x) = max_label;
                direction = 7;
                completed = false;
                current_y = y;
                current_x = x;
                while(~completed)

                    if(mod(direction,2)==1)
                        direction = mod(direction+6, 8);
                    else
                        direction = mod(direction+7, 8);
                    end
                    currently_at_y = current_y;
                    currently_at_x = current_x;
                    for i = 0:7
                        current_step = steps(direction+1,:);
                        current_y = currently_at_y+current_step(1);
                        current_x = currently_at_x+current_step(2);
                        if(image_matrix(current_y, current_x)==1)
                            if(current_x==x && current_y == y)
                                completed = true;
                                break;
                            end
                            paths(current_y, current_x)=max_label;
                            break;
                        end
                        current_y = currently_at_y;
                        current_x = currently_at_x;
                        direction = mod(direction + 1, 8);
                    end
                end
            else
                paths(y,x) = neighbour_label;
            end
        end
    end
end
no_of_regions = max_label-1;